#include "thgoodness.h"
#include "thspells.h"
#include "thdualsprites.h" //this is included cause it has rotset functions as well... should break those up

#include "marisaspells.h" //this is ony to get her grimoire for test...
#include "gfx/all_gfx.h" //this is also only for test to get the boxsprites (that fall )
#include "thentities.h"

#include "enemyhit.h"
#include "graze.h"


u16 thSpellsCompleted;	//how many total spells u completed

struct MyVars elVars[MAXENTITIES][MAXELEMENTS];	//Please dont have more than MAXELEMENTS elements! or else :P

u8 thSpellComleteGlobal;



//entity stuffs here temporarily


//int enemy;
int enemySafe=0;	//if set to 1 enemy cannot die or be detect hits

//Summon Entity table
struct Entity entities[MAXENTITIES];
struct SpellState spstates[MAXENTITIES]; //stores states for running spell

//setup our new spell plz (spell 0 = start!)
//reallt should be thSpellsInit(struct Spells *grim) { globalcurgrim=grim; ?
void thSpellsInit(void) {
	int x=0;
	int y=0;
//	enemys[1].curspell=spell;	//this enemy lib suxor! only handles boss atm tho can do all if i took out the enemys[1] all over heh
//	enemys[1].curSpellTime=0;
	timeLived=0;	//this should be zeroed elsewhere prolly
	thSpellsCompleted=0;
	do {
		do {
			elVars[x][y].gpcnt0=0; //reset the counters
			elVars[x][y].gpcnt1=0; //
			elVars[x][y].fcnt=0; //This one should be reset every player death
			elVars[x][y].var0=0;
			elVars[x][y].var1=0;				
			elVars[x][y].dlycnt=0;				
		} while(++y!=MAXELEMENTS);
		y=0;
		spstates[x].dlycnt=0;	//yah sure, ynot put this here and not enemys section (im confused should consolidate them, or not??)
	}while(++x!=MAXENTITIES);
}

//an enemy is a spell who is a bullet who is a sprite :D

//This function starts a spell (other spell should prolly be stopped first or @_@)
//also prolly dont NEED grimoire here/spell, just pointer to the grimoire[spell]
//will save cycles in the update loop too! :DDD 

//this should be named thEntitySpellCast as its an entity but it casts a spell so ~_~ 
//mebbe its best to think of it as a entitiy/spells lib? or that only entities can cast spells??
void thSpellCast(int entity, int spell) {
	int y=0;
	if(entities[entity].flags) {	//better make sure i exist first...
		spstates[entity].mvndx=0;		//al
		spstates[entity].mvwait=0;		//al
		spstates[entity].var0=0;
		spstates[entity].var1=0;
		spstates[entity].curspell=spell;	//this enemy lib suxor! on
		spstates[entity].curSpellTime=0;
		spstates[entity].flags=SPELL_ACTIVE;
		spstates[entity].dlycnt=spstates[entity].grimoire[spell].delay;	//set delay count can be used to delay this spell, only the movement
		do {	//
			elVars[entity][y].gpcnt0=0; //reset the counters
			elVars[entity][y].gpcnt1=0; //
			elVars[entity][y].fcnt=0; //This one should be reset every player death
			elVars[entity][y].var0=0;
			elVars[entity][y].var1=0;				
			elVars[entity][y].dlycnt=spstates[entity].grimoire[spell].spell[y].delay;				
		} while(++y!=MAXELEMENTS);
	}
//	PA_OutputText(0, 0,22, "%s        ",grimoire[spell].name);
}



void thSpellStop(int entity) {
	spstates[entity].flags=0;
	PA_OutputText(0, 0,22, "                  ");
}

void thEntityMove(int entity, int x, int y, int frames) {
	if(entities[entity].flags) {
		bulletsSetVector(entities[entity].bullet,x,y,frames);
	}
}

//Need pattern delay so that enemy health wont be affected during delay either!
//called at each enemy bullet refresh
void thSpellsBulletCallback(int bullet,int who) {
	u8 ndx=0;
//	u8 newspl=0;
	u32 curspell=spstates[who].curspell;
	struct Spells *grimoire=spstates[who].grimoire;
	if(spstates[who].mvfrmstp--==0) { //Reached end of time allocated to movement
		bulletsSetXinc(bullet,0);
		bulletsSetYinc(bullet,0);
	}
	if(grimoire[curspell].moves &&(spstates[who].mvwait--==0)) { //Time to change movement again (clean this up to use less asm instructions!!!!)
		if(grimoire[curspell].moves[spstates[who].mvndx].frms!=0) { //prevents div/0 error and allows no mvchng option
			bulletsSetXinc(bullet, ((grimoire[curspell].moves[spstates[who].mvndx].x<<8)-(bulletsGetRealX(bullet)<<8))/grimoire[curspell].moves[spstates[who].mvndx].frms);
			bulletsSetYinc(bullet, ((grimoire[curspell].moves[spstates[who].mvndx].y<<8)-(bulletsGetRealY(bullet)<<8))/grimoire[curspell].moves[spstates[who].mvndx].frms);
			spstates[who].mvfrmstp=grimoire[curspell].moves[spstates[who].mvndx].frms;
		}
		if(grimoire[curspell].moves[spstates[who].mvndx].wait!=0) {
			spstates[who].mvwait=grimoire[curspell].moves[spstates[who].mvndx].wait;	//set new wait time
			spstates[who].mvndx++;	//move to next ndx
		} else { //okai were at end of movement list... recycle 
			if(spstates[who].mvndx==0) { //is it the first one thats null?!
				spstates[who].mvwait=-1;		//if so then actually set it to -1 (wait forever
			} else {
				spstates[who].mvndx=0;		//al
				spstates[who].mvwait=0;		//set it to zero so it instantly will reload
			}
		}
	}
	if(spstates[who].dlycnt-->0) return; //dont go any further (coulda wrapped rest of this ginormous function in the if but jaja)
	thEraseTxtArea(0,0, 22, 23, 22);
//this if shouldnt be needed she we are explicitly specifying a spell now, u better just hope it exists! :P
	if(spstates[who].flags) { //We have a Spell to proform??
//IT SHOULD ONLY UPDATE SPELL TXT FOR BOSS, but this is for testing,,,
		PA_OutputText(0, 0,22, "%s",grimoire[curspell].name);
		while(grimoire[curspell].spell[ndx].func!=NULL) {
			if((elVars[who][ndx].dlycnt--<=0) && (((((_pSpellFunc)grimoire[curspell].spell[ndx].func)(bullet,who,spstates[who].curSpellTime,&elVars[who][ndx],grimoire[curspell].spell[ndx].arg0,grimoire[curspell].spell[ndx].arg1))==-1)
 || ((entities[who].health>>8)<=grimoire[curspell].health)))  {	
//				newspl=1;
				bulletsSetXinc(bullet,0);
				bulletsSetYinc(bullet,0);	//stop moving the enemy
				spstates[who].flags=0;	//stop spell :)
//these should be below in the ifnewspl==1 statement!?!
				if(!(grimoire[curspell].flags&SPELL_SAVESTATE)) { 
					elVars[who][ndx].gpcnt0=0; //reset the counters
					elVars[who][ndx].gpcnt0=0; //This one should be reset every player death
					elVars[who][ndx].fcnt=0; //This one should be reset every player death
					elVars[who][ndx].var0=0;
					elVars[who][ndx].var1=0;				
					spstates[who].curSpellTime=0;
					timeLived=0;	//we reset the amount of time we have lived with each spell
	
				}
				break;
			}
			ndx++;
		}
	}
	spstates[who].curSpellTime++;
}



void thEntitySetXYInc(int entity, int x, int y, int xinc, int yinc) {
		int size=bulletsGetSize(entities[entity].bullet)/2;
		int bullet=entities[entity].bullet;
		bulletsSetXvfl(bullet,(x-size)<<8);
		bulletsSetYvfl(bullet,(y-size)<<8);
		bulletsSetXinc(bullet,xinc);
		bulletsSetYinc(bullet,yinc);

}

//deletes an enemy
void thEntityBanish(int entity) {
	if(entities[entity].flags) {
		spstates[entity].flags=0;
		entities[entity].flags=0;
		//Note it may be left up to the "death bullet callback" which replaces the func* with its own and does a special deathy scene
		bulletsDestroy(entities[entity].bullet);
		bulletsDestroyAllFollow(entity); //get rid of any familiars following
		if(entities[entity].bgbullet>=0) bulletsDestroy(entities[entity].bgbullet);
	}
}

void thEntityInit(void) {
	int c=0;
	do {
		entities[c].flags=0;
	} while(++c!=MAXENTITIES);

}

volatile unsigned char entityDied=0;	//To indicate an enemy has perished 


//creates a entity
int thEntitySummon(int entity, Character *chr,int x, int y) {
	struct bsprite_s thenmy64={OBJ_SIZE_64X64,ENEMYPAL,64,32};
	struct badv_s badv={-1,0,0,&thSpellsBulletCallback,0,64,0}; // create advanced options bullet create struct
	u32 flags=BULLET_STICKY;
	entities[entity].flags=BULLET_ACTIVE;
	if(chr->class==CCLASS_PLYR) 
		thenmy64.pal=PLYRPAL;
	else if(chr->class==CCLASS_BOSS)
		thenmy64.pal=BOSSPAL;
	else if(chr->class==CCLASS_FAMILIAR)
		thenmy64.pal=FAMPAL;
	if(entity==0) {
		flags|=BULLET_ISPLAYER;
		badv.priority=125;	//highest priority (as i reserver upper sprites
	}
	thenmy64.hitrad=chr->hitsz;
	entities[entity].bullet=bulletCreate(chr->fgsprite, &thenmy64, x, y, 0, 0, -1,&badv,NULL,flags,entity);
	if(chr->bgsprite) {
//		thenmy64.pal=pal;	// temp crap 
		badv.func=NULL;
		badv.follow=entities[entity].bullet;
		badv.priority=100;	//make sure im on the bottom!  of entity
		badv.alpha=1;
		thenmy64.hitrad=-1;	//disable hits for familiar
		entities[entity].bgbullet=bulletCreate(chr->bgsprite, &thenmy64, x, y, 0,0, rotsetCreate(1000,0),&badv,NULL,flags|BULLET_FOLLOW,entity);
	} else {
		entities[entity].bgbullet=-1;
	}
//	PA_OutputText(1,5,9,"x:%d  y: %d       ",x,y );  	
//	enemys[c].mcnt=0; //should these mebbe countdown backwards and be settable??
//	enemys[c].fcnt=0;
	entities[entity].chr=chr;
//	entities[c].spell=0;
	entities[entity].health=25600;	//100% 
	spstates[entity].grimoire=chr->grimoire;
//	thSpellCast(entity, 0);  //  here,this function it should be passed the grimoir
	spstates[entity].mvwait=-1;		//al really only enemy will need to do this and player needs spell list!
	entities[entity].flags=ENTITY_ACTIVE;
	return(entity);
}

int thEntityUpdate(u32 *frame) {
	int c=0;
	int sqdis;
	s32 xc,yc;
	int who;
	int bc;
	int hitval;
//Check for bullet stuffs in here!!
	//simple collision detection :DD
	c=0;
	do {
		who=bulletsGetWho(c);
		//this really should be in the bullet library somehow? (how about the entitylib? :)
		if(bulletsGetFlags(c) && (bulletsGetHitrad(c)>=0)) {
			if(!(bulletsGetFlags(c)&BULLET_HIT) && !(bulletsGetFlags(c)&BULLET_FOLLOW)) {	//dont check for collisions if its sticky or following (and prolly should check if is > MAXENTITIES
				if(!(bulletsGetFlags(c)&BULLET_ISPLAYER)) {
					if(who==0) { //check for player's bullet col with enemy
							bc=1;
							do {
								if(entities[bc].flags) {
									xc=bulletsGetRealX(entities[bc].bullet);
									yc=bulletsGetRealY(entities[bc].bullet);
									sqdis=bulletsGetHitrad(c)+14; // in this case hitradius + charhitbox (this could be defined b4 this routine)
									if((PA_Distance(xc,yc,bulletsGetRealX(c),bulletsGetRealY(c))<sqdis*sqdis) && !(enemySafe)) {
										bulletsSetFlags(c,BULLET_HIT);
										if(thEntityGetHealth(bc)>0) {
											if(player.focused) {
												hitval=entities[bc].chr->speed;	
											} else {
												hitval=entities[bc].chr->fspeed;
											}
//	PA_OutputText(1, 14,5, "%s hitval: %d",entities[bc].chr->fspeed,hitval);						
											if(player.y-yc>0) {
												//subtract health points from enemy (closer the vert distnce = moar points!)
												//the amount this affects score should be in the player struct?									
												thEntityAddHeath(bc,(player.y-yc-hitval));
												//entities[bc].health+=(player.y-yc-256);	
											} else {
												thEntityAddHeath(bc,-(player.y-yc-hitval));
//												entities[bc].health-=hitval;
											}
//											if(entities[bc].chr->deathfunc) {	
//												entities[bc].chr->deathfunc;
//											}

//											bulletsDestroyAllWhoSize(entity, 32);
											
//											bulletsDestroy(c); //erase player's bullet
											player.score+=100; //will be times a multiplier or something later
											
										} else {
											if(!(thEntityGetFlags(bc)&ENTITY_HEALTH0)) {
												//here is transistion to health 0!
												thEntitySetFlags(bc, ENTITY_HEALTH0);
												if(entities[bc].chr->class!=CCLASS_BOSS) { // we let bossses destroy themselvs :D
													//you did it! u get a cookie :P (bonus boxes)
													bulletsReplaceAllWhoSizeDrop((void*)bbox_Sprite, bc, 16, -2,FAMPAL);
													thEntityBanish(bc);
												}
												player.score+=entities[bc].chr->points;
											}
//	PA_OutputText(1, 14,1, "died!!! ;_; ");
											thEntitySetHealth(bc,000);
											//entityDied=1;
											splbeattime=*frame;
										}
			//should be enemy hit sound(note, it will change pitch if health < 20%
										player.score+=entities[bc].chr->points>>8;	//get chr->points/256 points for hitting them
										PA_StopSound(10);
										if(entities[bc].health>5120) {
											PA_PlaySound(10, enemyhit,(u32)enemyhit_size,110,22050);
										} else {
											PA_PlaySound(10, enemyhit,(u32)enemyhit_size,110,23550);	
										}
										PA_SetSoundChannelPan(10, (u8)bulletsGetRealX(c)>>1);
					PA_OutputText(1, 7,2, "Enemy Health%d: %d\%   ",bc,entities[bc].health>>8);

									}
								}
							} while(++bc!=MAXENTITIES);
					} else { //check for enemy's bullet col with player
						if(who==-2) { //Check for bonus boxes 
									//these are getting rediculous, need to clean up this collision code
							sqdis=bulletsGetHitrad(c)+player.grazesz; // in this case hitradius + charhitbox sqdis=(bullets[c].hrad+hits)^2; ??
							if(PA_Distance(player.x,player.y,bulletsGetRealX(c),bulletsGetRealY(c))<(sqdis*sqdis)) {
								bulletsDestroy(c);
								PA_StopSound(9);
								PA_PlaySound(9, graze,(u32)graze_size,127,40000);
								PA_SetSoundChannelPan(9, (u8)player.x>>1);
								player.bonus+=128;
							}

						} else {
							if(who<MAXENTITIES) { // > max enemys we dont care about is other sprites...
								sqdis=bulletsGetHitrad(c)+player.hitsz; // in this case hitradius + charhitbox sqdis=(bullets[c].hrad+hits)^2; ??
								if((PA_Distance(player.x,player.y,bulletsGetRealX(c),bulletsGetRealY(c))<(sqdis*sqdis))&& !(gameFlags&GFLAGS_PSAFE)) {
//									bulletsSetFlags(c,BULLET_HIT);
									if(thPlayerHit(frame)) {
										return(-1); //way of ending for now
									} 
								}
							}

						}
					}
				} 				
			}
			//last we check for player graze collisions
			if((!(bulletsGetFlags(c)&BULLET_GRAZE)) && (bulletsGetWho(c)>0)) {
				sqdis=bulletsGetHitrad(c)+player.grazesz;
				if(PA_Distance(player.x,player.y,bulletsGetRealX(c),bulletsGetRealY(c))<(sqdis*sqdis)) {
					bulletsSetFlags(c,BULLET_GRAZE);
					PA_StopSound(9);
					PA_PlaySound(9, graze,(u32)graze_size,120,22050);
					PA_SetSoundChannelPan(9, (u8)player.x>>1);
//	PA_OutputText(0, 7,1, "pan: %d  ", (u8)player.x>>1);
//					PA_PlaySimpleSound(9, graze);
					player.graze++;	// increase graze points
				}
			}
		}
//for this hitbox stuff, u could have it say bulletCheckHits(whoru,x,y,FUNCPTR *hitfunct) to check for hits and call blah function each time
//also along these lines, instead of an 'enemy' system, how about a 'entity' system which handles similar stuff related to enemys and players ??
	} while(++c<BULLETS_MAX);

	if(!enemySafe) entities[1].health-=4;
	return(0);
}
