#ifndef SPELLS_H
#define SPELLS_H
#include <PA9.h>
#include "thgoodness.h"
//#include "thentities.h"
/* ~ooo The spell library stuff~ */

/* Spell organization
  Spell structure consists a function pointer, and arguments relating to the function
  Spells structure is an index all this character's spells where it is given spell name, pointer to an Spell array of one or more functions to proform, and arguments relating to ALL the functions within this spell. (compared to the each line of a spell has its own arguments for that particular function. an example would be spell delay which is in Spells telling it how long to wait before this spell starts, compared to the delay for each function so u can have like first the spinny stars, then the targeted attack, then the sideshooters etc)
  the grimoire[] array holds a list of Spells

just now thinking the spelldly might best go in the stagescript? nah then spell practice wouldnt give u a delay b4 start :D
 
*/


//what if the callback, just set a endofspell flag... then the game loop gets a ret value that indicates 
//  it should start another spell.. which it finds from an the

// spellStart(struct Spells *grimoire , int spell) - flag called thSpellCompleteGlobal tells gameloop this spell is ova via 
// macro which returns value of thSpellComplete;
// spellStart(stagescript[stagendx].character.grimoire, stagescript[stagendx].stepspell)  
//struct Spells *grimy=grimoire;

//magicbullet (to replace enemys ~_~)
//magicbullet (created by opponent's spells (or by stage start for the opponent herself) proforms a spell
/*

struct magicbullet {
	struct	Spells	*grimoire;
	int 	mvwait;
	int	mvndx;
	struct 	Myvars *myvars;
};
*/

//An array of these describes 
struct Spell {
	void	*func;	//function pointer ~_~
	int	xrel;	//Relative x,y position of this spell element to enemy's center
	int	yrel;
	int	delay;	//how long before this spell begins
	int	arg0;
	int	arg1;
};


struct spellMoves {
	int	x;		//Position i should be at for this spell
	int	y;
	int	frms;		//how many frames after spell starts till i should be in position? (-1=dont move)
	int	wait;		//how many frames before going on to the next movement step? (-1=no next movement)
};


//the spellIndex (mebbe instead have a position/time array for each spell?? rather than have the spell over and over it screws up
// meh plans  
// like x,y,frms, hold   where the hold param says how long till i grab next gframe?
struct Spells {
	const char *name;
	struct Spell *spell;	//since these are of varying length theyre here
	int	health;	//this spell stops at xx enemy health limit -1 for eternity
	int	duration;	//how long (in frames) this spell may last
	struct spellMoves *moves;	//movement script for this spell
	int	delay;		//delay how long before this spell starts?
	u8	flags;		//know ur gonna need em'
};

// Struct for storing spell element's specific runtime data
struct MyVars {
	int gpcnt0;
	int gpcnt1;
	int var0;
	int var1;
	int fcnt;
	int dlycnt;	//used to countdown to delay calling function... can also be set by the function to delay itself again woot! useful++
};


#define MAXELEMENTS 8
//The flags (which seem useless so far >_>)
#define SPELL_SAVESTATE	0x1	//dont erase spell's state variables! (aka myVars for the moment >_>)

extern u16 thSpellsCompleted;	//how many total spells u completed
extern struct MyVars elVars[MAXENTITIES][MAXELEMENTS];	//Please dont have more than MAXELEMENTS elements! or else :P
extern u8 thSpellComleteGlobal;
extern volatile unsigned char entityDied;	//To indicate an enemy has perished 


typedef int(*_pSpellFunc)(int,int,u32,struct MyVars *,int arg0, int arg1);	//Bullet function pointer type

#define thSpellComplete() (thSpellCompleteGlobal)

#define thSpellPause(e) (spstates[e].flags&=(SPELL_ACTIVE^0xffffffff))
#define thSpellResume(e) if(entities[e].flags) spstates[e].flags|=SPELL_ACTIVE;

#define thSpellStopMovement(e) 	spstates[(e)].mvfrmstp=0; spstates[(e)].mvwait=-1; if(entities[e].flags) {bullets[entities[e].bullet].xinc=0;bullets[entities[e].bullet].yinc=0;}

void thSpellCast(int entity, int spell); //This function starts a spell
void thSpellStop(int entity);

void thSpellsInit(void);
void thSpellsBulletCallback(int bullet,int who);





//Enemy Specific structure... this is used in conjunction with bullets which is now also controlling enemy movement ^^

//Okais, this is really starting to overlap with the spell library's functionality, esp since im using enemys[] to store 
//alot of spell state info hmmmzzz....... mebbe move it

#define SPELL_ACTIVE	0x1

struct SpellState {
	int	fcnt;	//countdown till next firing
	int	mcnt;	//countdown till next movement
	int	gpcnt0;	//generalpurpose counter (not auto inited!)
	int	gpcnt1;	//
	int 	var0;	//general purpose variable
	int	var1;
	u32	mvfrmstp;	//used by spells lib for moving around via spell variables
	u32	mvwait;
	u16	mvndx;		//which movement am i currently on
	int	curspell;
	struct Spells *grimoire;	//ok this should point to spellbook or hell just the spell and lose the index??!?!
	u32 curSpellTime;	//how long this spell has been active
	int 	dlycnt;		//delay till start of this spell and all it's elements which ofc have their own delays :D
	u32	flags;
};


extern struct SpellState spstates[];

/*
struct sEnemy {
//	int	xstop;	//where to stop if auto incrementing
//	int	ystop;	//these should prolly be in the bullets crap so can be used by them as well
	int 	bullet;	//which bullet is associated with this enemy
	int	bgbullet;	//which bullet is associated with the bg?
	int	health;	//health points 
//	u32 timeLived;	//how long the player's been alive on the current spell
	int	sprite;
	u8	rotset;
	u8	flags;
};
*/


#endif
