//Gfx converted using Mollusk's PAGfx Converter

//This file contains all the .h, for easier inclusion in a project

#ifndef ALL_GFX_H
#define ALL_GFX_H

#ifndef PAGfx_struct
    typedef struct{
    void *Map;
    int MapSize;
    void *Tiles;
    int TileSize;
    void *Palette;
    int *Info;
} PAGfx_struct;
#endif


// Sprite files : 
extern const unsigned char startgfx_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : menutxtp_Pal
extern const unsigned char musicroomgfx_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : menutxtp_Pal
extern const unsigned char resultsgfx_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : menutxtp_Pal
extern const unsigned char stage1gfx_Sprite[2048] __attribute__ ((aligned (4))) ;  // Pal : menutxtp_Pal
extern const unsigned char marisa0_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char redstar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char lightbluestar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bluestar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char greenstar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char yellostar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char purplestar_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bigyellostar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char biggreenstar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bigredstar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bigbluestar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bigpurplestar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char biglightbluestar_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char circle_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : marisapalp_Pal
extern const unsigned char bluemarisa_Sprite[8192] __attribute__ ((aligned (4))) ;  // Pal : bluemarisap_Pal
extern const unsigned char bluemarisasplitl_Sprite[2048] __attribute__ ((aligned (4))) ;  // Pal : bluemarisap_Pal
extern const unsigned char bluemarisasplitr_Sprite[2048] __attribute__ ((aligned (4))) ;  // Pal : bluemarisap_Pal
extern const unsigned char bluemarisabullet_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : bluemarisap_Pal
extern const unsigned char menumoon_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : moonp_Pal
extern const unsigned char octagram64x64_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char fambullet8x8_Sprite[64] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char fambullet16x16_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char famovalbullet16x16_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char angelsan32x32_Sprite[4096] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char leafred_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char leafgreen_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char leafblue_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char leaforange_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char leafyellow_Sprite[1024] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char bbox_Sprite[256] __attribute__ ((aligned (4))) ;  // Pal : fampalp_Pal
extern const unsigned char chocololigfx_Sprite[16384] __attribute__ ((aligned (4))) ;  // Pal : dialogp_Pal
extern const unsigned char properloligfx_Sprite[16384] __attribute__ ((aligned (4))) ;  // Pal : dialogp_Pal

// Background files : 
extern const int trees_Info[3]; // BgMode, Width, Height
extern const unsigned short trees_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : trees_Pal
extern const unsigned char trees_Tiles[52992] __attribute__ ((aligned (4))) ;  // Pal : trees_Pal
extern PAGfx_struct trees; // background pointer

extern const int trees_1_Info[3]; // BgMode, Width, Height
extern const unsigned short trees_1_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : trees_1_Pal
extern const unsigned char trees_1_Tiles[43840] __attribute__ ((aligned (4))) ;  // Pal : trees_1_Pal
extern PAGfx_struct trees_1; // background pointer

extern const int titlescreen_Info[3]; // BgMode, Width, Height
extern const unsigned short titlescreen_Map[768] __attribute__ ((aligned (4))) ;  // Pal : titlescreen_Pal
extern const unsigned char titlescreen_Tiles[48896] __attribute__ ((aligned (4))) ;  // Pal : titlescreen_Pal
extern PAGfx_struct titlescreen; // background pointer

extern const int background_Info[3]; // BgMode, Width, Height
extern const unsigned short background_Map[768] __attribute__ ((aligned (4))) ;  // Pal : background_Pal
extern const unsigned char background_Tiles[49152] __attribute__ ((aligned (4))) ;  // Pal : background_Pal
extern PAGfx_struct background; // background pointer

extern const int watchwarmly_Info[3]; // BgMode, Width, Height
extern const unsigned short watchwarmly_Map[768] __attribute__ ((aligned (4))) ;  // Pal : watchwarmly_Pal
extern const unsigned char watchwarmly_Tiles[49088] __attribute__ ((aligned (4))) ;  // Pal : watchwarmly_Pal
extern PAGfx_struct watchwarmly; // background pointer

extern const int bglvl1_1_Info[3]; // BgMode, Width, Height
extern const unsigned short bglvl1_1_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : bglvl1_1_Pal
extern const unsigned char bglvl1_1_Tiles[49472] __attribute__ ((aligned (4))) ;  // Pal : bglvl1_1_Pal
extern PAGfx_struct bglvl1_1; // background pointer

extern const int bglvl1_2_Info[3]; // BgMode, Width, Height
extern const unsigned char bglvl1_2_Map[1024] __attribute__ ((aligned (4))) ;  // Pal : bglvl1_2_Pal
extern const unsigned char bglvl1_2_Tiles[14080] __attribute__ ((aligned (4))) ;  // Pal : bglvl1_2_Pal
extern PAGfx_struct bglvl1_2; // background pointer


// Palette files : 
extern const unsigned short menutxtp_Pal[3] __attribute__ ((aligned (4))) ;
extern const unsigned short marisapalp_Pal[206] __attribute__ ((aligned (4))) ;
extern const unsigned short bluemarisap_Pal[112] __attribute__ ((aligned (4))) ;
extern const unsigned short moonp_Pal[212] __attribute__ ((aligned (4))) ;
extern const unsigned short fampalp_Pal[246] __attribute__ ((aligned (4))) ;
extern const unsigned short dialogp_Pal[91] __attribute__ ((aligned (4))) ;
extern const unsigned short trees_Pal[17] __attribute__ ((aligned (4))) ;
extern const unsigned short trees_1_Pal[27] __attribute__ ((aligned (4))) ;
extern const unsigned short titlescreen_Pal[245] __attribute__ ((aligned (4))) ;
extern const unsigned short background_Pal[117] __attribute__ ((aligned (4))) ;
extern const unsigned short watchwarmly_Pal[226] __attribute__ ((aligned (4))) ;
extern const unsigned short bglvl1_1_Pal[24] __attribute__ ((aligned (4))) ;
extern const unsigned short bglvl1_2_Pal[17] __attribute__ ((aligned (4))) ;


#endif

